/***************************************************************
	int.h
	 .

	RTL2 -    /.

	() ., 2000.
	   .
 ***************************************************************/
/***************************************************************
	 :
	24.10.2005 , 
		   .

 ***************************************************************/

#ifndef INT_H
#define INT_H

#include "types.h"
#include "access.h"
#include "config.h"

#ifdef __cplusplus
extern "C" {
#endif

/***************************************************************
         .
    msp_SetVReg/msp_GetVReg,  
 ***************************************************************/

#define msp_GetIntMask(device) msp_ReadReg(device, mspRR_INTERRUPT_MASK)
#define msp_SetIntMask(device, mask) msp_WriteReg(device, mspRR_INTERRUPT_MASK, mask)
#define msp_GetIntStatus(device) msp_ReadReg(device, mspRR_INTERRUPT_STATUS)

/***************************************************************
      
 ***************************************************************/

//msp_InterruptInfo :    
//\    
typedef struct {
	msp_WORD status;		// INTERRUPT STATUS   
							//!!    UISR  INTERRUPT MASK
							//!!    
							//UISR     (  ),
							//    IUSR
	msp_DEVHANDLE device;	// 
	msp_STKHANDLE stack;	//   
	msp_WORD stack_entry;	//    
	msp_RAMHANDLE object;	// .  -  ,  
} msp_InterruptInfo;

//\    
typedef void (*msp_UISR)(msp_InterruptInfo* Info);

//    
typedef struct {
	msp_WORD mask;			// 
	msp_UISR UISR;			//\  
} msp_DispatchInfo;

msp_ERROR msp_UISR_SetTable(msp_DEVHANDLE device, msp_DispatchInfo* Table);
//    
//device - 
//Table -   
//		  -   .
//		    Info = NULL
//
//       .
// ,  DispatchInfo->status & InterruptInfo->mask,
//  \ DispatchInfo->UISR
//
//      .

void msp_UISR_Dispatch(msp_DEVHANDLE device);
// .      
//    msp_SetISR() (access.h)
//      
//     (msp_ResetInterrupt())

void msp_MultiRT_Dispatch(msp_DEVHANDLE device);
//      .
//     
//    msp_SetISR() (access.h)
//      

/***************************************************************
      
 ***************************************************************/

msp_ERROR msp_UISR_LinkToHandle(msp_RAMHANDLE handle, 
								msp_UISR UISR);
// \       
//handle - ,  msp_BUFHANDLE  msp_MSGHANDLE
//UISR - \  , .  
//		  ,    
//		   UISR  NULL

void msp_UISR_DispatchToHandle(msp_InterruptInfo* Info);
//   .
//   msp_UISR    
//    \ msp_UISR_SetTable
//Info -   
//   Info handle . 
//  \ ,    
// msp_UISR_LinkToHandle

/***************************************************************/

#ifdef __cplusplus
}
#endif

#endif
